// dynamic.cpp

// a diabolical test program for nested_graph template class.


//////////////////////////////////////////////////////////////
//
//  Copyright 2000   Simple Investments. 
//
//  Released into the public domain 27th June 2002.
//  Please change, sell, claim as your own, whatever you like.
//
//////////////////////////////////////////////////////////////

// dynamic.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <conio.h>

#include "nested.h"

#if 1

#include <iostream>
#include <string>
#include <list>
#include <ggcl/dynamic_graph.h>

using std::cout;
using std::endl;

typedef plugin<id_tag,std::size_t> ID;
typedef plugin<name_tag,std::string> Name;
typedef nested_graph<directedS, ID, Name, Name> Graph;

void display_graph(Graph &g, int indent=0)
{
  vertex_property_accessor<Graph,id_tag>::type id
    = get_vertex_property(g, id_tag());

  edge_property_accessor<Graph,name_tag>::type name
    = get_edge_property(g, name_tag());
  
  Graph::vertex_iterator i, end;
  Graph::out_edge_iterator ei, edge_end;
  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    for (int k=0; k<indent; ++k) std::cout << " ";
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    if (is_composite_vertex(g, *i))
    {
      Graph *g2 = get_child_graph(g, *i);
      std::cout << std::endl;
      display_graph(*g2, indent + 2);
    }
    else
      std::cout << std::endl;
  }
}

int main(int,char*[])
{

  Graph g;

  Graph::vertex_descriptor v[9];
  v[1] = add_vertex(g, ID(1));
  v[2] = add_composite_vertex(g, ID(2));
  v[3] = add_vertex(g, ID(3));
  Graph *g2 = get_child_graph(g, v[2]);
  v[4] = add_vertex(*g2, ID(4));
  v[5] = add_vertex(*g2, ID(5));
  v[6] = add_composite_vertex(*g2, ID(10));

  Graph *g3 = get_child_graph(*g2, v[6]);
  v[7] = add_vertex(*g3, ID(11));
  v[8] = add_vertex(*g3, ID(12));
  Graph::edge_descriptor e;
  Graph *eg;
  boost::tie(e, eg) = add_edge(g, v[1], *g3, v[7], Name("E4"));
  add_edge(*g3, v[7], *g3, v[8], Name("E5"));

  Graph::port_descriptor p1 = add_port(g, v[1], Name("Port1"));
  Graph::port_descriptor p2 = add_port(*g2, v[4], Name("Port2"));
  add_edge_from_ports(g, p1, p2, Name("EP"));

  add_edge(g, v[1], *g2, v[4], Name("E1"));
  add_edge(*g2, v[4], *g2, v[5], Name("E2"));
  add_edge(*g2, v[5], g, v[3], Name("E3"));
//  add_edge(g, v[1], g, v[3], Name("E3"));
//  add_edge(g, v[3], g, v[1], Name("E2"));
//  add_edge_from_ports(g, p1, p2, Name("EdgeName"));

  display_graph(g);

  vertex_property_accessor<Graph, vert_portlist_tag>::type ports
    = get_vertex_property(g, vert_portlist_tag());

  // display all the ports for v1
  port_property_accessor<Graph::PortGraph,port_edge_tag>::type edges
    = get_port_property(g, port_edge_tag());

  port_property_accessor<Graph::PortGraph,port_vertex_tag>::type vertexes
    = get_port_property(g, port_vertex_tag());

  port_property_accessor<Graph::PortGraph,name_tag>::type portname
    = get_port_property(g, name_tag());

  for (int i=1; i<=8; ++i) {
    if (ports[v[i]].size()  > 0) {
      Graph::port_descriptor px = &(v[i])[0];
      cout << "v" << i << " has " << ports[v[i]].size() << "ports (" << vertexes[px] << ")" << endl;
      cout << "    ";
      for (int j=0; j<ports[v[i]].size(); ++j) cout << portname[(ports[v[i]])[j]] << ",";
      cout << endl;
    } else
      cout << "v" << i << " has " << ports[v[i]].size() << "ports (" << "NULL" << ")" << endl;

  }

  string problem;
  if (!validate_graph(g, problem)) {
    cout << "graph validation failed : " << problem << endl;
  } else {
    cout << "graph validation successsful" << endl;
  }

  remove_edge(*eg, e);
  remove_edge(g, p1, p2);
  remove_port(g, p1);
//  display_graph(g);

  if (!validate_graph(g, problem)) {
    cout << "graph validation failed : " << problem << endl;
  } else {
    cout << "graph validation successsful" << endl;
  }

  display_graph(g);


  Graph *sg = new Graph;
  Graph::vertex_descriptor v1 = add_vertex(*sg, ID(1000));
  Graph::vertex_descriptor v2 = add_vertex(*sg, ID(1001));
  add_edge(*sg, v1, v2, Name("SubEdge"));
  Graph::vertex_descriptor cv = add_composite_vertex(g, ID(999));

  {
    v[1] = add_vertex(*sg, ID(91));
    v[2] = add_composite_vertex(*sg, ID(92));
    v[3] = add_vertex(*sg, ID(93));
    g2 = get_child_graph(*sg, v[2]);
    v[4] = add_vertex(*g2, ID(94));
    v[5] = add_vertex(*g2, ID(95));
    v[6] = add_composite_vertex(*g2, ID(910));

    g3 = get_child_graph(*g2, v[6]);
    v[7] = add_vertex(*g3, ID(911));
    v[8] = add_vertex(*g3, ID(912));
    boost::tie(e, eg) = add_edge(*sg, v[1], *g3, v[7], Name("E94"));
    add_edge(*g3, v[7], *g3, v[8], Name("E95"));

    Graph::port_descriptor p1 = add_port(*sg, v[1], Name("Port91"));
    Graph::port_descriptor p2 = add_port(*g2, v[4], Name("Port92"));
    add_edge_from_ports(*sg, p1, p2, Name("9EP"));

    add_edge(*sg, v[1], *g2, v[4], Name("E91"));
    add_edge(*g2, v[4], *g2, v[5], Name("E92"));
    add_edge(*g2, v[5], *sg, v[3], Name("E93"));
  }

  insert_subgraph(g, cv, sg);

  display_graph(g);

  if (!validate_graph(g, problem)) {
    cout << "graph validation failed : " << problem << endl;
  } else {
    cout << "graph validation successsful" << endl;
  }

  expand_graph(g);

  display_graph(g);

  if (!validate_graph(g, problem)) {
    cout << "graph validation failed : " << problem << endl;
  } else {
    cout << "graph validation successsful" << endl;
  }

//  cout << edges[p1];
/*
  using namespace ggcl;
  const int N = 5;
  typedef plugin<id_tag,std::size_t> ID;
  typedef plugin<name_tag,std::string> Name;
  typedef dynamic_graph< directedS, ID, Name > Graph;
//  typedef nested_graph< directedS, ID, Name , no_plugin> Graph;
  Graph g;
  Graph::vertex_descriptor v[N];

  vertex_property_accessor<Graph,id_tag>::type id
    = get_vertex_property(g, id_tag());

  edge_property_accessor<Graph,name_tag>::type name
    = get_edge_property(g, name_tag());


  for (int k = 0; k < N; ++k)
    v[k] = add_vertex(g, ID(k));

  add_edge(g, v[0], v[1], Name("joe"));
  add_edge(g, v[1], v[2], Name("curly"));
  add_edge(g, v[3], v[4], Name("dick"));
  add_edge(g, v[2], v[4], Name("tom"));
  add_edge(g, v[1], v[3], Name("harry"));
  
  Graph::vertex_iterator i, end;
  Graph::out_edge_iterator ei, edge_end;
  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }
  
  remove_edge(g, v[1], v[3]);
  std::cout << "After removing edge (1,3): " << std::endl;

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }

  cout << "Removing Vertex" << std::endl;
  remove_vertex(g, v[0]);

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }
  
  remove_edge(g, v[1], v[3]);
  std::cout << "After removing edge (1,3): " << std::endl;

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }
*/
  _getch();

  return 0;
}

#endif











































#if 0

#include <iostream>
#include <vector>
#include <utility>

#include <ggcl/adjacency_list.h>
#include <ggcl/bidir_adj_list.h>

using std::cout;
using std::endl;

int main(int argc, char* argv[])
{
  using namespace ggcl;
  typedef adjacency_list<mapS, undirectedS, color_plugin<> > ALGraph;
//  typedef bidir_adj_list<listS, color_plugin<> > ALGraph;
  

  ALGraph g(0);

//  add_vertex(g);
//  add_vertex(g);
//  add_vertex(g);
//  add_vertex(g);
//  add_vertex(g);
//  remove_vertex(g, 0);
//  remove_vertex(g, 1);
//  remove_vertex(g, 2);
//  remove_vertex(g, 3);
//  remove_vertex(g, 4);

  add_edge(g, 0, 1);
  add_edge(g, 1, 2);
  add_edge(g, 1, 3);
  add_edge(g, 2, 4);
  add_edge(g, 3, 4);

  ALGraph::vertex_iterator i, end;
  ALGraph::incidence_iterator ei, edge_end;
  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    cout << index(*i) << " --> ";
//	Vertex *v = *i;
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      cout << index(target(*ei, g)) << "  ";
    cout << endl;
  }

  
  remove_edge(g, 1, 3);
  cout << "After removing edge (1,3): " << endl;

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    cout << index(*i) << " --> ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      cout << index(target(*ei, g)) << "  ";
    cout << endl;
  }

  cout << "Adding Vertex" << endl;

  remove_vertex(g, 2);
  add_vertex(g);

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    cout << index(*i) << " --> ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      cout << index(target(*ei, g)) << "  ";
    cout << endl;
  }

 
  cout << "After removing edge (1,3): " << endl;

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    cout << index(*i) << " --> ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      cout << index(target(*ei, g)) << "  ";
    cout << endl;
  }

  ALGraph k;
  k = g

  cout << "Copying graph" << endl;
  for(boost::tie(i,end) = vertices(k); i != end; ++i) {
    cout << index(*i) << " --> ";
    for (boost::tie(ei,edge_end) = out_edges(*i, k); ei != edge_end; ++ei)
      cout << index(target(*ei, k)) << "  ";
    cout << endl;
  }

  _getch();

  return 0;
}

// dynamic.cpp : Defines the entry point for the console application.
//

#endif

#if 0
#include <iostream>
#include <string>
#include <list>
#include <ggcl/dynamic_graph.h>

using std::cout;
using std::endl;

typedef plugin<id_tag,std::size_t> ID;
typedef plugin<name_tag,std::string> Name;
typedef nested_graph<directedS, ID, Name, Name> Graph;

int main()
{
  using namespace ggcl;
  const int N = 5;
  typedef plugin<id_tag,std::size_t> ID;
  typedef plugin<name_tag,std::string> Name;
  typedef dynamic_graph< directedS, ID, Name > Graph;
//  typedef nested_graph< directedS, ID, Name , no_plugin> Graph;
  Graph g;
  Graph::vertex_descriptor v[N];

  vertex_property_accessor<Graph,id_tag>::type id
    = get_vertex_property(g, id_tag());

  edge_property_accessor<Graph,name_tag>::type name
    = get_edge_property(g, name_tag());


  for (int k = 0; k < N; ++k)
    v[k] = add_vertex(g, ID(k));

  add_edge(g, v[0], v[1], Name("joe"));
  add_edge(g, v[1], v[2], Name("curly"));
  add_edge(g, v[3], v[4], Name("dick"));
  add_edge(g, v[2], v[4], Name("tom"));
  add_edge(g, v[1], v[3], Name("harry"));
  
  Graph::vertex_iterator i, end;
  Graph::out_edge_iterator ei, edge_end;
  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }
  
  remove_edge(g, v[1], v[3]);
  std::cout << "After removing edge (1,3): " << std::endl;

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }

  cout << "Removing Vertex" << std::endl;
  remove_vertex(g, v[0]);

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }
  
  remove_edge(g, v[1], v[3]);
  std::cout << "After removing edge (1,3): " << std::endl;

  for(boost::tie(i,end) = vertices(g); i != end; ++i) {
    std::cout << id[*i] << "(" << *i << ")" << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, g); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, g)] << "  ";
    std::cout << std::endl;
  }

  Graph copy(g);
//  copy = g;

  std::cout << "Copied" << std::endl;

  for(boost::tie(i,end) = vertices(copy); i != end; ++i) {
    std::cout << id[*i] << "(" << *i << ")" << " ";
    for (boost::tie(ei,edge_end) = out_edges(*i, copy); ei != edge_end; ++ei)
      std::cout << " --" << name[*ei] << "--> " << id[target(*ei, copy)] << "  ";
    std::cout << std::endl;
  }

  _getch();

  return 0;
}

#endif